#---------------------------------------------------------------------------
#
#   SuPy GUI - TextField - Generic
#
#---------------------------------------------------------------------------

from properties import overridable_property
from widget import Widget
from control import Control

class GTextField(Widget, Control):

	text = overridable_property('text', "Text in the field")
	datatype = overridable_property('datatype', "Function for converting text to value")
	format = overridable_property('format', "Format string for converting value to text")
	empty = overridable_property('empty', "Value represented by empty field")
	
	_datatype = str
	_format = "%s"
	_empty = ""

	def get_value(self):
		return self.parse_text(self.text)
	
	def set_value(self, x):
		self.text = self.format_value(x)
	
	def get_datatype(self):
		return self._datatype
	
	def set_datatype(self, x):
		self._datatype = x
	
	def get_format(self):
		return self._format
	
	def set_format(self, x):
		self._format = x
	
	def get_empty(self):
		return self._empty
	
	def set_empty(self, x):
		self._empty = x
	
	def parse_text(self, text):
		if not text:
			value = self.empty
		else:
			dt = self.datatype
			try:
				value = dt(text)
			except ValueError:
				value = dt()
		return value

	def format_value(self, value):
		if value == self.empty:
			return ""
		else:
			return self.format % value
